package net.mcreator.prehisticraft;

import net.minecraftforge.fml.relauncher.SideOnly;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.common.registry.EntityRegistry;
import net.minecraftforge.fml.common.registry.EntityEntryBuilder;
import net.minecraftforge.fml.common.event.FMLPreInitializationEvent;
import net.minecraftforge.fml.common.event.FMLInitializationEvent;
import net.minecraftforge.fml.client.registry.RenderingRegistry;

import net.minecraft.world.biome.Biome;
import net.minecraft.world.World;
import net.minecraft.util.math.MathHelper;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.math.AxisAlignedBB;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.DamageSource;
import net.minecraft.item.ItemStack;
import net.minecraft.item.Item;
import net.minecraft.init.Items;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.ai.EntityMoveHelper;
import net.minecraft.entity.ai.EntityAISwimming;
import net.minecraft.entity.ai.EntityAIPanic;
import net.minecraft.entity.ai.EntityAILookIdle;
import net.minecraft.entity.ai.EntityAIHurtByTarget;
import net.minecraft.entity.ai.EntityAIBase;
import net.minecraft.entity.ai.EntityAIAvoidEntity;
import net.minecraft.entity.SharedMonsterAttributes;
import net.minecraft.entity.MoverType;
import net.minecraft.entity.EnumCreatureType;
import net.minecraft.entity.EnumCreatureAttribute;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.EntityCreature;
import net.minecraft.entity.Entity;
import net.minecraft.client.renderer.entity.RenderLiving;
import net.minecraft.client.model.ModelRenderer;
import net.minecraft.client.model.ModelBox;
import net.minecraft.client.model.ModelBase;
import net.minecraft.block.state.IBlockState;

import java.util.Random;
import java.util.HashMap;

@Elementsprehisticraft.ModElement.Tag
public class MCreatorMeganeura extends Elementsprehisticraft.ModElement {
	public static final int ENTITYID = 3;
	public static final int ENTITYID_RANGED = 4;

	public MCreatorMeganeura(Elementsprehisticraft instance) {
		super(instance, 16);
	}

	@Override
	public void initElements() {
		elements.entities.add(() -> EntityEntryBuilder.create().entity(EntityCustom.class)
				.id(new ResourceLocation("prehisticraft", "meganeura"), ENTITYID).name("meganeura").tracker(64, 1, true).egg(-16751104, -16764160)
				.build());
	}

	@Override
	public void init(FMLInitializationEvent event) {
		Biome[] spawnBiomes = {Biome.REGISTRY.getObject(new ResourceLocation("prehisticraft:coalforest")),
				Biome.REGISTRY.getObject(new ResourceLocation("prehisticraft:carboniferousplains")),};
		EntityRegistry.addSpawn(EntityCustom.class, 20, 1, 6, EnumCreatureType.CREATURE, spawnBiomes);
	}

	@SideOnly(Side.CLIENT)
	@Override
	public void preInit(FMLPreInitializationEvent event) {
		RenderingRegistry.registerEntityRenderingHandler(EntityCustom.class, renderManager -> {
			return new RenderLiving(renderManager, new Modelmeganeura(), 0.3f) {
				protected ResourceLocation getEntityTexture(Entity entity) {
					return new ResourceLocation("prehisticraft:textures/meganeura.png");
				}
			};
		});
	}

	public static class EntityCustom extends EntityCreature {
		public EntityCustom(World world) {
			super(world);
			setSize(0.7999999999999999f, 1f);
			experienceValue = 5;
			this.isImmuneToFire = false;
			setNoAI(!true);
			this.tasks.addTask(1, new EntityAIBase() {
				{
					this.setMutexBits(1);
				}

				@Override
				public boolean shouldExecute() {
					EntityMoveHelper entitymovehelper = EntityCustom.this.getMoveHelper();
					if (!entitymovehelper.isUpdating()) {
						return true;
					} else {
						double dx = entitymovehelper.getX() - EntityCustom.this.posX;
						double dy = entitymovehelper.getY() - EntityCustom.this.posY;
						double dz = entitymovehelper.getZ() - EntityCustom.this.posZ;
						double d = dx * dx + dy * dy + dz * dz;
						return d < 1 || d > 3600;
					}
				}

				@Override
				public boolean shouldContinueExecuting() {
					return false;
				}

				@Override
				public void startExecuting() {
					Random random = EntityCustom.this.getRNG();
					double dir_x = EntityCustom.this.posX + ((random.nextFloat() * 2 - 1) * 16);
					double dir_y = EntityCustom.this.posY + ((random.nextFloat() * 2 - 1) * 16);
					double dir_z = EntityCustom.this.posZ + ((random.nextFloat() * 2 - 1) * 16);
					EntityCustom.this.getMoveHelper().setMoveTo(dir_x, dir_y, dir_z, 0.8);
				}
			});
			this.moveHelper = new EntityMoveHelper(this) {
				private int patchChangeTimer;

				@Override
				public void onUpdateMoveHelper() {
					if (this.action == EntityMoveHelper.Action.MOVE_TO) {
						double dx = this.posX - EntityCustom.this.posX;
						double dy = this.posY - EntityCustom.this.posY;
						double dz = this.posZ - EntityCustom.this.posZ;
						double d = dx * dx + dy * dy + dz * dz;
						if (this.patchChangeTimer-- <= 0) {
							this.patchChangeTimer += EntityCustom.this.getRNG().nextInt(5) + 2;
							d = (double) MathHelper.sqrt(d);
							if (this.isNotColliding(this.posX, this.posY, this.posZ, d)) {
								EntityCustom.this.motionX += dx / d * 0.1;
								EntityCustom.this.motionY += dy / d * 0.1;
								EntityCustom.this.motionZ += dz / d * 0.1;
							} else {
								this.action = EntityMoveHelper.Action.WAIT;
							}
						}
					}
				}

				private boolean isNotColliding(double x, double y, double z, double par) {
					double dx = (x - EntityCustom.this.posX) / par;
					double dy = (y - EntityCustom.this.posY) / par;
					double dz = (z - EntityCustom.this.posZ) / par;
					AxisAlignedBB axisalignedbb = EntityCustom.this.getEntityBoundingBox();
					for (int i = 1; (double) i < par; ++i) {
						axisalignedbb = axisalignedbb.offset(dx, dy, dz);
						if (!EntityCustom.this.world.getCollisionBoxes(EntityCustom.this, axisalignedbb).isEmpty())
							return false;
					}
					return true;
				}
			};
			this.tasks.addTask(2, new EntityAILookIdle(this));
			this.tasks.addTask(3, new EntityAISwimming(this));
			this.tasks.addTask(4, new EntityAIPanic(this, 1.2));
			this.targetTasks.addTask(5, new EntityAIHurtByTarget(this, false));
			this.tasks.addTask(6, new EntityAIAvoidEntity(this, EntityPlayer.class, (float) 6, 1, 1.2));
			this.tasks.addTask(7, new EntityAIAvoidEntity(this, EntityPlayerMP.class, (float) 6, 1, 1.2));
		}

		@Override
		public EnumCreatureAttribute getCreatureAttribute() {
			return EnumCreatureAttribute.ARTHROPOD;
		}

		@Override
		protected Item getDropItem() {
			return new ItemStack(Items.SPIDER_EYE, (int) (1)).getItem();
		}

		@Override
		public net.minecraft.util.SoundEvent getAmbientSound() {
			return (net.minecraft.util.SoundEvent) net.minecraft.util.SoundEvent.REGISTRY.getObject(new ResourceLocation(""));
		}

		@Override
		public net.minecraft.util.SoundEvent getHurtSound(DamageSource ds) {
			return (net.minecraft.util.SoundEvent) net.minecraft.util.SoundEvent.REGISTRY.getObject(new ResourceLocation("entity.squid.hurt"));
		}

		@Override
		public net.minecraft.util.SoundEvent getDeathSound() {
			return (net.minecraft.util.SoundEvent) net.minecraft.util.SoundEvent.REGISTRY.getObject(new ResourceLocation("entity.squid.death"));
		}

		@Override
		protected float getSoundVolume() {
			return 1.0F;
		}

		@Override
		public void fall(float l, float d) {
		}

		@Override
		public boolean attackEntityFrom(DamageSource source, float amount) {
			if (source == DamageSource.FALL)
				return false;
			if (source == DamageSource.CACTUS)
				return false;
			return super.attackEntityFrom(source, amount);
		}

		@Override
		public void onDeath(DamageSource source) {
			super.onDeath(source);
			int x = (int) this.posX;
			int y = (int) this.posY;
			int z = (int) this.posZ;
			Entity entity = this;
			{
				java.util.HashMap<String, Object> $_dependencies = new java.util.HashMap<>();
				$_dependencies.put("x", x);
				$_dependencies.put("y", y);
				$_dependencies.put("z", z);
				$_dependencies.put("world", world);
				MCreatorMeganeuraDrop.executeProcedure($_dependencies);
			}
		}

		@Override
		protected void applyEntityAttributes() {
			super.applyEntityAttributes();
			if (this.getEntityAttribute(SharedMonsterAttributes.ARMOR) != null)
				this.getEntityAttribute(SharedMonsterAttributes.ARMOR).setBaseValue(0D);
			if (this.getEntityAttribute(SharedMonsterAttributes.MOVEMENT_SPEED) != null)
				this.getEntityAttribute(SharedMonsterAttributes.MOVEMENT_SPEED).setBaseValue(0.6D);
			if (this.getEntityAttribute(SharedMonsterAttributes.MAX_HEALTH) != null)
				this.getEntityAttribute(SharedMonsterAttributes.MAX_HEALTH).setBaseValue(4D);
			if (this.getEntityAttribute(SharedMonsterAttributes.ATTACK_DAMAGE) != null)
				this.getEntityAttribute(SharedMonsterAttributes.ATTACK_DAMAGE).setBaseValue(3D);
		}

		@Override
		public void travel(float ti, float tj, float tk) {
			Entity entity = this.getPassengers().isEmpty() ? null : (Entity) this.getPassengers().get(0);
			if (this.isBeingRidden()) {
				this.rotationYaw = entity.rotationYaw;
				this.prevRotationYaw = this.rotationYaw;
				this.rotationPitch = entity.rotationPitch * 0.5F;
				this.setRotation(this.rotationYaw, this.rotationPitch);
				this.jumpMovementFactor = this.getAIMoveSpeed() * 0.15F;
				this.renderYawOffset = entity.rotationYaw;
				this.rotationYawHead = entity.rotationYaw;
				this.stepHeight = 1.0F;
				if (entity instanceof EntityLivingBase) {
					this.setAIMoveSpeed((float) this.getEntityAttribute(SharedMonsterAttributes.MOVEMENT_SPEED).getAttributeValue());
					float forward = ((EntityLivingBase) entity).moveForward;
					float strafe = ((EntityLivingBase) entity).moveStrafing;
					super.travel(strafe, 0, forward);
				}
				this.prevLimbSwingAmount = this.limbSwingAmount;
				double d1 = this.posX - this.prevPosX;
				double d0 = this.posZ - this.prevPosZ;
				float f1 = MathHelper.sqrt(d1 * d1 + d0 * d0) * 4.0F;
				if (f1 > 1.0F)
					f1 = 1.0F;
				this.limbSwingAmount += (f1 - this.limbSwingAmount) * 0.4F;
				this.limbSwing += this.limbSwingAmount;
				return;
			}
			this.stepHeight = 0.5F;
			this.jumpMovementFactor = 0.02F;
			if (this.isInWater()) {
				this.moveRelative(ti, tj, tk, 0.02f);
				this.move(MoverType.SELF, this.motionX, this.motionY, this.motionZ);
				this.motionX *= 0.8;
				this.motionY *= 0.8;
				this.motionZ *= 0.8;
				return;
			}
			if (this.isInLava()) {
				this.moveRelative(ti, tj, tk, 0.02f);
				this.move(MoverType.SELF, this.motionX, this.motionY, this.motionZ);
				this.motionX *= 0.5;
				this.motionY *= 0.5;
				this.motionZ *= 0.5;
				return;
			}
			float f = 0.91F;
			if (this.onGround) {
				BlockPos underPos = new BlockPos(MathHelper.floor(this.posX), MathHelper.floor(this.getEntityBoundingBox().minY) - 1,
						MathHelper.floor(this.posZ));
				IBlockState underState = this.world.getBlockState(underPos);
				f = underState.getBlock().getSlipperiness(underState, this.world, underPos, this) * 0.91F;
			}
			this.moveRelative(ti, tj, tk, this.onGround ? 0.1f * 0.16f / (f * f * f) : 0.02F);
			f = 0.91F;
			if (this.onGround) {
				BlockPos underPos = new BlockPos(MathHelper.floor(this.posX), MathHelper.floor(this.getEntityBoundingBox().minY) - 1,
						MathHelper.floor(this.posZ));
				IBlockState underState = this.world.getBlockState(underPos);
				f = underState.getBlock().getSlipperiness(underState, this.world, underPos, this) * 0.91F;
			}
			this.move(MoverType.SELF, this.motionX, this.motionY, this.motionZ);
			this.motionX *= (double) f;
			this.motionY *= (double) f;
			this.motionZ *= (double) f;
			this.prevLimbSwingAmount = this.limbSwingAmount;
			double d1 = this.posX - this.prevPosX;
			double d0 = this.posZ - this.prevPosZ;
			float f2 = MathHelper.sqrt(d1 * d1 + d0 * d0) * 4.0F;
			if (f2 > 1)
				f2 = 1;
			this.limbSwingAmount += (f2 - this.limbSwingAmount) * 0.4F;
			this.limbSwing += this.limbSwingAmount;
		}

		@Override
		protected void updateFallState(double y, boolean onGroundIn, IBlockState state, BlockPos pos) {
		}
	}

	// Made with Blockbench
	// Paste this code into your mod.
	public static class Modelmeganeura extends ModelBase {
		private final ModelRenderer Head;
		private final ModelRenderer BodyS1;
		private final ModelRenderer BodyS2;
		private final ModelRenderer RightWing;
		private final ModelRenderer LeftWing;
		private final ModelRenderer Leg1;
		private final ModelRenderer Leg2;
		private final ModelRenderer Leg3;
		private final ModelRenderer Leg4;
		private final ModelRenderer Leg5;
		private final ModelRenderer Leg6;

		public Modelmeganeura() {
			textureWidth = 128;
			textureHeight = 128;
			Head = new ModelRenderer(this);
			Head.setRotationPoint(-2.0F, 13.0F, -9.0F);
			Head.cubeList.add(new ModelBox(Head, 0, 0, -2.0F, -2.0F, -4.0F, 4, 4, 4, 0.0F, false));
			BodyS1 = new ModelRenderer(this);
			BodyS1.setRotationPoint(0.0F, 24.0F, 0.0F);
			BodyS1.cubeList.add(new ModelBox(BodyS1, 104, 117, -4.0F, -13.0F, -9.0F, 4, 3, 8, 0.0F, false));
			BodyS2 = new ModelRenderer(this);
			BodyS2.setRotationPoint(0.0F, 24.0F, 0.0F);
			BodyS2.cubeList.add(new ModelBox(BodyS2, 92, 110, -3.0F, -13.0F, -1.0F, 2, 2, 16, 0.0F, false));
			RightWing = new ModelRenderer(this);
			RightWing.setRotationPoint(-1.0F, 11.0F, -6.0F);
			RightWing.cubeList.add(new ModelBox(RightWing, 88, 0, 1.0F, 0.0F, -3.0F, 15, 0, 5, 0.0F, false));
			LeftWing = new ModelRenderer(this);
			LeftWing.setRotationPoint(-3.5F, 11.0F, -6.5F);
			LeftWing.cubeList.add(new ModelBox(LeftWing, 88, 0, -15.5F, 0.0F, -2.5F, 15, 0, 5, 0.0F, false));
			Leg1 = new ModelRenderer(this);
			Leg1.setRotationPoint(0.0F, 24.0F, 0.0F);
			Leg1.cubeList.add(new ModelBox(Leg1, 0, 125, -1.0F, -10.0F, -8.0F, 1, 2, 1, 0.0F, false));
			Leg2 = new ModelRenderer(this);
			Leg2.setRotationPoint(0.0F, 24.0F, 0.0F);
			Leg2.cubeList.add(new ModelBox(Leg2, 0, 125, -1.0F, -10.0F, -5.0F, 1, 2, 1, 0.0F, false));
			Leg3 = new ModelRenderer(this);
			Leg3.setRotationPoint(0.0F, 24.0F, 0.0F);
			Leg3.cubeList.add(new ModelBox(Leg3, 0, 125, -1.0F, -10.0F, -2.0F, 1, 2, 1, 0.0F, false));
			Leg4 = new ModelRenderer(this);
			Leg4.setRotationPoint(0.0F, 24.0F, 0.0F);
			Leg4.cubeList.add(new ModelBox(Leg4, 0, 125, -4.0F, -10.0F, -2.0F, 1, 2, 1, 0.0F, false));
			Leg5 = new ModelRenderer(this);
			Leg5.setRotationPoint(0.0F, 24.0F, 0.0F);
			Leg5.cubeList.add(new ModelBox(Leg5, 0, 125, -4.0F, -10.0F, -5.0F, 1, 2, 1, 0.0F, false));
			Leg6 = new ModelRenderer(this);
			Leg6.setRotationPoint(0.0F, 24.0F, 0.0F);
			Leg6.cubeList.add(new ModelBox(Leg6, 0, 125, -4.0F, -10.0F, -8.0F, 1, 2, 1, 0.0F, false));
		}

		@Override
		public void render(Entity entity, float f, float f1, float f2, float f3, float f4, float f5) {
			Head.render(f5);
			BodyS1.render(f5);
			BodyS2.render(f5);
			RightWing.render(f5);
			LeftWing.render(f5);
			Leg1.render(f5);
			Leg2.render(f5);
			Leg3.render(f5);
			Leg4.render(f5);
			Leg5.render(f5);
			Leg6.render(f5);
		}

		public void setRotationAngle(ModelRenderer modelRenderer, float x, float y, float z) {
			modelRenderer.rotateAngleX = x;
			modelRenderer.rotateAngleY = y;
			modelRenderer.rotateAngleZ = z;
		}

		public void setRotationAngles(float f, float f1, float f2, float f3, float f4, float f5, Entity e) {
			super.setRotationAngles(f, f1, f2, f3, f4, f5, e);
			this.Head.rotateAngleY = f3 / (180F / (float) Math.PI);
			this.Head.rotateAngleX = f4 / (180F / (float) Math.PI);
			this.LeftWing.rotateAngleY = MathHelper.cos(f * 0.6662F) * f1;
			this.RightWing.rotateAngleY = MathHelper.cos(f * 0.6662F + (float) Math.PI) * f1;
		}
	}
}
